use regex::Regex;

pub fn pt1(input: &str) -> usize {
    let re = Regex::new(r"mul\((\d+),(\d+)\)").unwrap();
    re.captures_iter(input)
        .map(|c| c.extract())
        .map(|(_, [x, y])| x.parse::<usize>().unwrap() * y.parse::<usize>().unwrap())
        .sum()
}

pub fn pt2(input: &str) -> usize {
    let re = Regex::new(r"mul\((\d+),(\d+)\)").unwrap();
    re.captures_iter(
        &Regex::new(r"don't\(\).*?do\(\)")
            .unwrap()
            .replace_all(&input.replace('\n', ""), ""),
    )
    .map(|c| c.extract())
    .map(|(_, [x, y])| x.parse::<usize>().unwrap() * y.parse::<usize>().unwrap())
    .sum()
}

#[cfg(test)]
mod tests {
    use std::fs::read_to_string;

    use super::{pt1, pt2};

    #[test]
    pub fn test_pt1() {
        let input =
            read_to_string("./inputs/day03/example.txt").expect("Missing example.txt for day03");
        assert_eq!(pt1(&input), 161)
    }
    #[test]
    pub fn test_pt2() {
        let input = read_to_string("./inputs/day03/example_2.txt")
            .expect("Missing example_2.txt for day03");

        assert_eq!(pt2(&input), 48)
    }
}
